# prc04s.py (encoding: cp932)
  # g敪~ʂ̃NXWv\JCQ挟ɂ
  # vʓ̂قAϑxAςݎc\
  # printł̕\̂قAExcelt@Cւ̏o͂s
import pandas as pd
from rpy2.robjects import r
from textwrap import dedent
import xlwt
import pyrcmd as prc
prc.set_charset('cp932')

src_file = 'data.csv'
rscript = dedent(u'''\
    dtf <- read.csv("%s", header=T, fileEncoding="%s")
    dtf$ <- factor(dtf$, levels=c("j", ""),
      labels=c("j", ""))
    cc <- cut(dtf$g, breaks=c(-Inf, 155, 165, 175, Inf),
        labels=c("155", "155`165", "165`175", "175ȏ"), right=FALSE)
    dtf <- cbind(dtf, g敪=cc)
    tbl <- table(dtf$g敪, dtf$)
    chi_test <- chisq.test(tbl)
    chi_test
    ''') % (src_file, prc.get_charset(src_file))
prc.rexec(rscript, sink=False)  # RR}h̎s
chi_test = r['chi_test']  # rp2IuWFNg(ListVector)ƂĎ擾
pod = prc.rp2pd(chi_test)  # ListVectorϊ(OrderedDictɂȂ)
chi2 = pod['statistic'][0]  # JCQl
df = pod['parameter'][0]  # Rx
p_value = pod['p.value']  # Lӊm̒l

print(u'JCQ挟̌')
print("chi2: %f, df: %d, p-value: %g\n" % (chi2, df, p_value))
print(u"ϑx")
print(pod['observed'])
print('')
print(u"ςݎc")
print(pod['stdres'])

writer = pd.ExcelWriter("prc04s.xls")
pod['observed'].to_excel(writer, startrow=4, startcol=0)  # ϑx
worksheet = writer.sheets['Sheet1']
worksheet.write(0, 0, u"JCQ挟̌")
worksheet.write(1, 0, "chi2: %f, df: %d, p-value: %g" % (chi2, df, p_value))
worksheet.write(3, 0, u"ϑx")
nr = worksheet.last_used_row + 2  # ŉs̎̎
worksheet.write(nr, 0, u"ςݎc")
nr = nr + 1
pod['stdres'].to_excel(writer, startrow=nr, startcol=0)
writer.save()
